<template>
	<v-row justify="center">
		<v-card width="500">
			<v-form class="form" ref="form">
				<v-text-field
					label="Full name"
					v-model="fullname"></v-text-field>
				<v-text-field
					label="Username"
					v-model="form_username"
					:rules="nameRules"
					counter
					required></v-text-field>
				<v-text-field
					label="E-mail"
					prepend-icon="email"
					v-model="email"
					:rules="emailRules"
					required></v-text-field>
				<v-text-field
					label="Password"
					prepend-icon="lock"
					:append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
					:type="show ? 'text' : 'password'"
					v-model="form_password"
					:rules="passwordRules"
					@click:append="show = !show"
					counter
					required></v-text-field>
				<v-select
					item-text="countryname"
					item-value="abbr"
					v-model="form_country"
					:items="items"
					:rules="countryRules"
					label="Country"
					return-value
					required></v-select>
				<v-row justify="center">
					<v-btn class="submit" block color="success" @click="userRegister(form_username,form_password, form_country)">Sign up</v-btn>

					<v-dialog
						v-model="dialog"
						max-width="290">
						<v-card>
							<v-card-title class="text-h">
								Signed up successfully!
							</v-card-title>

							<v-card-actions>
								<v-spacer></v-spacer>
								<v-btn
									color="green darken-1"
									text
									@click="nextPage()">
									Log in!
								</v-btn>
							</v-card-actions>
						</v-card>
					</v-dialog>
					<v-snackbar v-model="dialogwrong" bottom right color="error">
						Please fill everything correctly!
					</v-snackbar>
				</v-row>
			</v-form>
		</v-card>
	</v-row>
</template>

<script>
import { httpPost } from '@/utils/connection';
export default {
	name: "Register",
	data: () => ({
		items: [{ countryname: 'Belgium', abbr: 'BE' }, { countryname: 'Czech Republic', abbr: 'CZ' }, { countryname: 'Germany', abbr: 'DE' }, { countryname: 'Hungary', abbr: 'HU' }, { countryname: 'Iceland', abbr: 'IS' }, { countryname: 'Norway', abbr: 'NO' }],
		valid: true,
		dialog: false,
		dialogwrong: false,
		show: false,
		email: "",
		emailRules: [
			v => !!v || "E-mail is required",
			v => /.+@.+\..+/.test(v) || "E-mail must be valid"
		],
		form_username: "",
		nameRules: [
			v => !!v || "Nickname is required",
			v => (v && v.length <= 10) || "Name must be less than 10 characters"
		],
		form_password: "",
		passwordRules: [
			v => !!v || "Password is required",
			v =>
				(v && v.length >= 8) ||
				"Password must be at least than 8 characters"
		],
		fullname: "",
		form_country: "",
		countryRules: [
			v => !!v || "Country is required",
		],
	}
	),
	methods: {
		userRegister: async function (form_username, form_password, form_country) {
	
			if (this.$refs.form.validate()) {
				var response = await httpPost(process.env.VUE_APP_API_URL + "/register", {
					username: form_username,
					password: form_password,
					country: form_country,
				})
				if (response) {
					console.log("Sikeres regisztráció");
					this.dialog = true;
				}
			} else {
				this.dialogwrong = true;
			}
			return;

		},
		nextPage: function () {
			this.$router.push('/login');
			return;
		}
	},
};
</script>

<style scoped>
.submit {
	margin-top: 30px;
}
.form {
	padding: 30px;
}
</style>